mod api;
mod repo;

use axum::{Router, Server};
use tower_http::trace::TraceLayer;

pub fn app(global: crate::Global, api_key: &str) -> Router {
    Router::new()
        .nest("/api", api::router())
        .merge(repo::router(api_key))
        .with_state(global)
        .layer(TraceLayer::new_for_http())
}

pub async fn serve(app: Router, port: u16) -> Result<(), hyper::Error> {
    Server::bind(&format!("0.0.0.0:{}", port).parse().unwrap())
        .serve(app.into_make_service())
        .await
}
